// This file is a part of the Framsticks GDK library.
// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
// Refer to http://www.framsticks.com/ for further information.

#include "stdiofile.h"
#include "nonstd_dir.h"
#include "nonstd_stdio.h"
#include "framsg.h"

VirtFILE* StdioFileSystem::Vfopen(const char* path,const char*mode)
{
	//FMprintf("Vfopen %s %s",path,mode);
	FILE *f=fopen(path,mode);
	//FMprintf("%p",f);
	if (f) return new StdioFILE(f,path); else return 0;
}

VirtDIR* StdioFileSystem::Vopendir(const char* path)
{
	//FMprintf("Vopendir %s",path);
	DIR *d=opendir(path);
	//FMprintf("%p",d);
	if (d) return new StdioDIR(d); else return 0;
}

int StdioFileSystem::Vfexists(const char* path)
{
	return fileExists(path);
}

void StdioFILE::setStdio()
{
	static StdioFILEDontClose si(stdin);
	static StdioFILEDontClose so(stdout);
	static StdioFILEDontClose se(stderr);
	setVstdin(&si);
	setVstdout(&so);
	setVstderr(&se);
}

dirent* StdioDIR::Vreaddir()
{
	//FMprintf("Vreaddir %s",dir);
	return readdir(dir);
}
